LibreOffice LibreOffice 5.3 SDK C/C++ API Reference

Namespaces | Classes | Typedefs | Functions
cppu Namespace Reference

## Namespaces
| detail
| EnvDcp
| helper

## Classes
class | AccessControl
| Helper class retriving access controller singleton from component context. More...
class | AggImplInheritanceHelper1
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | AggImplInheritanceHelper10
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | AggImplInheritanceHelper11
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | AggImplInheritanceHelper12
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | AggImplInheritanceHelper13
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | AggImplInheritanceHelper2
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | AggImplInheritanceHelper3
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | AggImplInheritanceHelper4
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | AggImplInheritanceHelper5
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | AggImplInheritanceHelper6
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | AggImplInheritanceHelper7
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | AggImplInheritanceHelper8
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | AggImplInheritanceHelper9
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | AntiEnvGuard
| Environment Anti-Guard Any entered Environment becomes left in the constructor and re-entered in the destructor. More...
class | BaseMutex
| base class for all classes who want derive from cppu::WeakComponentImplHelperXX. More...
class | BootstrapException
| An exception indicating a bootstrap error. More...
struct | ContextEntry_Init
| Context entries init struct calling createComponentContext(). More...
class | Enterable
| C++ wrapper for binary C Enterable (http://wiki.openoffice.org/wiki/Uno/Cpp/Spec/Environment_Stack) More...
class | EnvGuard
| Environment Guard The provided Environment becomes entered in the constructor and left in the destructor. More...
struct | equalInt32_Impl
struct | hashInt32_Impl
struct | hashType_Impl
class | IEventNotificationHook
| An interface to extend event notification actions. More...
struct | ImplementationEntry
| One struct instance represents all data necessary for registering one service implementation. More...
class | ImplHelper1
| Implementation helper implementing interface css::lang::XTypeProvider and method XInterface::queryInterface(), but no reference counting. More...
class | ImplHelper10
| Implementation helper implementing interface css::lang::XTypeProvider and method XInterface::queryInterface(), but no reference counting. More...
class | ImplHelper11
| Implementation helper implementing interface css::lang::XTypeProvider and method XInterface::queryInterface(), but no reference counting. More...
class | ImplHelper12
| Implementation helper implementing interface css::lang::XTypeProvider and method XInterface::queryInterface(), but no reference counting. More...
class | ImplHelper13
| Implementation helper implementing interface css::lang::XTypeProvider and method XInterface::queryInterface(), but no reference counting. More...
class | ImplHelper2
| Implementation helper implementing interface css::lang::XTypeProvider and queryInterface(), but no reference counting. More...
class | ImplHelper3
| Implementation helper implementing interface css::lang::XTypeProvider and method XInterface::queryInterface(), but no reference counting. More...
class | ImplHelper4
| Implementation helper implementing interface css::lang::XTypeProvider and method XInterface::queryInterface(), but no reference counting. More...
class | ImplHelper5
| Implementation helper implementing interface css::lang::XTypeProvider and method XInterface::queryInterface(), but no reference counting. More...
class | ImplHelper6
| Implementation helper implementing interface css::lang::XTypeProvider and method XInterface::queryInterface(), but no reference counting. More...
class | ImplHelper7
| Implementation helper implementing interface css::lang::XTypeProvider and method XInterface::queryInterface(), but no reference counting. More...
class | ImplHelper8
| Implementation helper implementing interface css::lang::XTypeProvider and method XInterface::queryInterface(), but no reference counting. More...
class | ImplHelper9
| Implementation helper implementing interface css::lang::XTypeProvider and method XInterface::queryInterface(), but no reference counting. More...
class | ImplInheritanceHelper1
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | ImplInheritanceHelper10
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | ImplInheritanceHelper11
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | ImplInheritanceHelper12
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | ImplInheritanceHelper13
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | ImplInheritanceHelper2
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | ImplInheritanceHelper3
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | ImplInheritanceHelper4
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | ImplInheritanceHelper5
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | ImplInheritanceHelper6
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | ImplInheritanceHelper7
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | ImplInheritanceHelper8
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | ImplInheritanceHelper9
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface inherting from a BaseClass. More...
class | IPropertyArrayHelper
| This interface is used by the OPropertyHelper, to access the property description. More...
struct | OBroadcastHelperVar
| This struct contains the standard variables of a broadcaster. More...
class | OComponentHelper
| Deprecated. More...
class | OImplementationId
| Helper class to implement IDs for XUnoTunnel. More...
class | OInterfaceContainerHelper
| A container of interfaces. More...
class | OInterfaceIteratorHelper
| This is the iterator of a InterfaceContainerHelper. More...
class | OMultiTypeInterfaceContainerHelper
| Specialized class for key type css::uno::Type, without explicit usage of STL symbols. More...
class | OMultiTypeInterfaceContainerHelperInt32
| Specialized class for key type sal_Int32, without explicit usage of STL symbols. More...
class | OMultiTypeInterfaceContainerHelperVar
| A helper class to store interface references of different types. More...
class | OPropertyArrayHelper
| You can use this helper class to map a XPropertySet-Interface to a XFast- or a XMultiPropertySet interface. More...
class | OPropertySetHelper
| This abstract class maps the methods of the interfaces XMultiPropertySet, XFastPropertySet and XPropertySet to the methods getInfoHelper, convertFastPropertyValue, setFastPropertyValue_NoBroadcast and getFastPropertyValue. More...
class | OPropertySetHelper2
| OPropertySetHelper plus XPropertySetOption. More...
class | OTypeCollection
| Helper class to implement css::lang::XTypeProvider. More...
class | OWeakAggObject
| Base class to implement an UNO object supporting weak references, i.e. More...
class | OWeakObject
| Base class to implement an UNO object supporting weak references, i.e. More...
class | PartialWeakComponentImplHelper1
| Same as WeakComponentImplHelper1, except doesn't implement addEventListener, removeEventListener and dispose. More...
class | PartialWeakComponentImplHelper10
| Same as WeakComponentImplHelper10, except doesn't implement addEventListener, removeEventListener and dispose. More...
class | PartialWeakComponentImplHelper11
| Same as WeakComponentImplHelper11, except doesn't implement addEventListener, removeEventListener and dispose. More...
class | PartialWeakComponentImplHelper12
| Same as WeakComponentImplHelper12, except doesn't implement addEventListener, removeEventListener and dispose. More...
class | PartialWeakComponentImplHelper2
| Same as WeakComponentImplHelper2, except doesn't implement addEventListener, removeEventListener and dispose. More...
class | PartialWeakComponentImplHelper3
| Same as WeakComponentImplHelper3, except doesn't implement addEventListener, removeEventListener and dispose. More...
class | PartialWeakComponentImplHelper4
| Same as WeakComponentImplHelper4, except doesn't implement addEventListener, removeEventListener and dispose. More...
class | PartialWeakComponentImplHelper5
| Same as WeakComponentImplHelper5, except doesn't implement addEventListener, removeEventListener and dispose. More...
class | PartialWeakComponentImplHelper6
| Same as WeakComponentImplHelper6, except doesn't implement addEventListener, removeEventListener and dispose. More...
class | PartialWeakComponentImplHelper7
| Same as WeakComponentImplHelper7, except doesn't implement addEventListener, removeEventListener and dispose. More...
class | PartialWeakComponentImplHelper8
| Same as WeakComponentImplHelper8, except doesn't implement addEventListener, removeEventListener and dispose. More...
class | PartialWeakComponentImplHelper9
| Same as WeakComponentImplHelper9, except doesn't implement addEventListener, removeEventListener and dispose. More...
class | PropertySetMixin
| A helper mixin to implement certain UNO interfaces related to property set handling on top of the attributes of a given UNO interface type. More...
class | PropertySetMixinImpl
| A helper base class for `cppu::PropertySetMixin`. More...
struct | UnoSequenceType
| A unique C++ type template representing the UNO sequence types in cppu::UnoType. More...
class | UnoType
| Get the css::uno::Type instance representing a certain UNO type. More...
class | UnoUrl
| Parse UNO URLs into their components. More...
class | UnoUrlDescriptor
| A descriptor as part of a UNO URL (connection descriptor or protocol descriptor). More...
class | WeakAggComponentImplHelper1
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakAggComponentImplHelper10
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakAggComponentImplHelper11
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakAggComponentImplHelper12
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakAggComponentImplHelper2
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakAggComponentImplHelper3
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakAggComponentImplHelper4
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakAggComponentImplHelper5
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakAggComponentImplHelper6
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakAggComponentImplHelper7
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakAggComponentImplHelper8
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakAggComponentImplHelper9
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakAggImplHelper1
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakAggObject). More...
class | WeakAggImplHelper10
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakAggObject). More...
class | WeakAggImplHelper11
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakAggObject). More...
class | WeakAggImplHelper12
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakAggObject). More...
class | WeakAggImplHelper13
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakAggObject). More...
class | WeakAggImplHelper2
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakAggObject). More...
class | WeakAggImplHelper3
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakAggObject). More...
class | WeakAggImplHelper4
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakAggObject). More...
class | WeakAggImplHelper5
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak thru cppu::OWeakAggObject). More...
class | WeakAggImplHelper6
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakAggObject). More...
class | WeakAggImplHelper7
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakAggObject). More...
class | WeakAggImplHelper8
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakAggObject). More...
class | WeakAggImplHelper9
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakAggObject). More...
class | WeakComponentImplHelper1
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakComponentImplHelper10
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakComponentImplHelper11
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakComponentImplHelper12
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakComponentImplHelper2
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakComponentImplHelper3
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakComponentImplHelper4
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakComponentImplHelper5
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakComponentImplHelper6
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakComponentImplHelper7
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakComponentImplHelper8
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakComponentImplHelper9
| Implementation helper supporting css::lang::XTypeProvider and css::lang::XComponent. More...
class | WeakImplHelper1
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakObject). More...
class | WeakImplHelper10
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakObject). More...
class | WeakImplHelper11
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakObject). More...
class | WeakImplHelper12
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakObject). More...
class | WeakImplHelper13
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakObject). More...
class | WeakImplHelper2
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakObject). More...
class | WeakImplHelper3
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakObject). More...
class | WeakImplHelper4
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakObject). More...
class | WeakImplHelper5
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak thru cppu::OWeakObject). More...
class | WeakImplHelper6
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakObject). More...
class | WeakImplHelper7
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakObject). More...
class | WeakImplHelper8
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakObject). More...
class | WeakImplHelper9
| Implementation helper implementing interfaces css::lang::XTypeProvider and css::uno::XInterface which supports weak mechanism to be held weakly (supporting css::uno::XWeak through cppu::OWeakObject). More...

## Typedefs
typedef css::uno::Reference< css::uno::XInterface >(* | ComponentFactoryFunc) (css::uno::Reference< css::uno::XComponentContext > const &xContext)
| Function pointer declaration. More...
typedef css::uno::Reference< css::uno::XInterface >(* | ComponentInstantiation) (const css::uno::Reference< css::lang::XMultiServiceFactory > &rServiceManager)
| Deprecated. More...
typedef OBroadcastHelperVar< OMultiTypeInterfaceContainerHelper, OMultiTypeInterfaceContainerHelper::keyType > | OBroadcastHelper

## Functions
void | Enterable_call_enter (void *context)
void | Enterable_call_leave (void *context)
void | Enterable_call_callInto_v (void *context, uno_EnvCallee *pCallee, va_list *pParam)
void | Enterable_call_callOut_v (void *context, uno_EnvCallee *pCallee, va_list *pParam)
int | Enterable_call_isValid (void *context, rtl_uString **pReason)
template<class T >
T * | mapOut (T *pT, css::uno::Environment const &outerEnv)
| Helpers for mapping objects relative to the current environment. More...
template<class T >
T * | mapIn (T *pT, css::uno::Environment const &outerEnv)
| Maps an object from an outer Environment to the current, returns mapped object. More...
void | mapOutAny (css::uno::Any const &any, css::uno::Any *res, css::uno::Environment const &outerEnv)
| Maps an any from the current to an outer Environment, fills passed any. More...
void | mapInAny (css::uno::Any const &any, css::uno::Any *res, css::uno::Environment const &outerEnv)
| Maps an any from an outer Environment to the current, fills passed any. More...
template<typename T >
css::uno::Type const & | getTypeFavourUnsigned (SAL_UNUSED_PARAMETER T const *)
| A working replacement for getCppuType (see there). More...
css::uno::Type const & | getTypeFavourUnsigned (SAL_UNUSED_PARAMETER ::sal_uInt16 const *)
| A working replacement for getCppuType (see there). More...
template<typename T >
css::uno::Type const & | getTypeFavourUnsigned (css::uno::Sequence< T > const *)
| A working replacement for getCppuType (see there). More...
CPPUHELPER_DLLPUBLIC sal_Bool | installTypeDescriptionManager (css::uno::Reference< css::container::XHierarchicalNameAccess > const &xTDMgr)
| Installs type description manager instance, i.e. More...
CPPUHELPER_DLLPUBLIC css::uno::Reference< css::uno::XComponentContext > | defaultBootstrap_InitialComponentContext ()
| Bootstraps an initial component context with service manager upon information from bootstrap variables. More...
CPPUHELPER_DLLPUBLIC css::uno::Reference< css::uno::XComponentContext > | defaultBootstrap_InitialComponentContext (const ::rtl::OUString &iniFile)
| Bootstraps an initial component context with service manager upon information from an ini file. More...
CPPUHELPER_DLLPUBLIC css::uno::Reference< css::uno::XComponentContext > | bootstrap ()
| Bootstraps the component context from a UNO installation. More...
CPPUHELPER_DLLPUBLIC css::uno::Reference< css::uno::XComponentContext > | createComponentContext (ContextEntry_Init const *pEntries, sal_Int32 nEntries, css::uno::Reference< css::uno::XComponentContext > const &xDelegate=css::uno::Reference< css::uno::XComponentContext >())
| Creates a component context with the given entries. More...
CPPUHELPER_DLLPUBLIC void | throwException (const css::uno::Any &rExc)
| This function throws the exception given by rExc. More...
CPPUHELPER_DLLPUBLIC css::uno::Any | getCaughtException ()
| Use this function to get the dynamic type of a caught C++-UNO exception; completes the above function throwing exceptions generically. More...
CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleComponentFactory > | createSingleComponentFactory (ComponentFactoryFunc fptr, ::rtl::OUString const &rImplementationName, css::uno::Sequence< ::rtl::OUString > const &rServiceNames, rtl_ModuleCount *pModCount=NULL)
| Creates a single component factory supporting the XSingleComponentFactory interface. More...
CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleComponentFactory > | createOneInstanceComponentFactory (ComponentFactoryFunc fptr, ::rtl::OUString const &rImplementationName, css::uno::Sequence< ::rtl::OUString > const &rServiceNames, rtl_ModuleCount *pModCount=NULL)
| Creates a single service factory which holds the instance created only once. More...
CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleServiceFactory > | createSingleFactory (const css::uno::Reference< css::lang::XMultiServiceFactory > &rServiceManager, const ::rtl::OUString &rImplementationName, ComponentInstantiation pCreateFunction, const css::uno::Sequence< ::rtl::OUString > &rServiceNames, rtl_ModuleCount *pModCount=NULL)
| Deprecated. More...
CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleServiceFactory > | createFactoryProxy (const css::uno::Reference< css::lang::XMultiServiceFactory > &rServiceManager, const css::uno::Reference< css::lang::XSingleServiceFactory > &rFactory)
| Deprecated. More...
CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleServiceFactory > | createOneInstanceFactory (const css::uno::Reference< css::lang::XMultiServiceFactory > &rServiceManager, const ::rtl::OUString &rComponentName, ComponentInstantiation pCreateFunction, const css::uno::Sequence< ::rtl::OUString > &rServiceNames, rtl_ModuleCount *pModCount=NULL)
| Deprecated. More...
CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleServiceFactory > | createSingleRegistryFactory (const css::uno::Reference< css::lang::XMultiServiceFactory > &rServiceManager, const ::rtl::OUString &rImplementationName, const css::uno::Reference< css::registry::XRegistryKey > &rImplementationKey)
| Deprecated. More...
CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleServiceFactory > | createOneInstanceRegistryFactory (const css::uno::Reference< css::lang::XMultiServiceFactory > &rServiceManager, const ::rtl::OUString &rComponentName, const css::uno::Reference< css::registry::XRegistryKey > &rImplementationKey)
| Deprecated. More...
CPPUHELPER_DLLPUBLIC sal_Bool | component_writeInfoHelper (void *pServiceManager, void *pRegistryKey, const struct ImplementationEntry entries[])
| Helper function for implementation of the component_writeInfo()-function. More...
CPPUHELPER_DLLPUBLIC void * | component_getFactoryHelper (const sal_Char *pImplName, void *pServiceManager, void *pRegistryKey, const struct ImplementationEntry entries[])
| Helper function for implementation of the component_getFactory()-function, that must be implemented by every shared library component. More...
template<class target >
void | convertPropertyValue (target &value, const css::uno::Any &a)
| Converts the value stored in an any to a concrete C++ type. More...
void | convertPropertyValue (sal_Bool &target, const css::uno::Any &source)
| conversion of basic types More...
void | convertPropertyValue (bool &target, const css::uno::Any &source)
void | convertPropertyValue (sal_Int64 &target, const css::uno::Any &source)
void | convertPropertyValue (sal_uInt64 &target, const css::uno::Any &source)
void | convertPropertyValue (sal_Int32 &target, const css::uno::Any &source)
void | convertPropertyValue (sal_uInt32 &target, const css::uno::Any &source)
void | convertPropertyValue (sal_Int16 &target, const css::uno::Any &source)
void | convertPropertyValue (sal_uInt16 &target, const css::uno::Any &source)
void | convertPropertyValue (sal_Int8 &target, const css::uno::Any &source)
void | convertPropertyValue (float &target, const css::uno::Any &source)
void | convertPropertyValue (double &target, const css::uno::Any &source)
template<class Interface1 >
css::uno::Any | queryInterface (const css::uno::Type &rType, Interface1 *p1)
| Compares demanded type to given template argument types. More...
template<class Interface1 , class Interface2 >
css::uno::Any | queryInterface (const css::uno::Type &rType, Interface1 *p1, Interface2 *p2)
| Compares demanded type to given template argument types. More...
template<class Interface1 , class Interface2 , class Interface3 >
css::uno::Any | queryInterface (const css::uno::Type &rType, Interface1 *p1, Interface2 *p2, Interface3 *p3)
| Compares demanded type to given template argument types. More...
template<class Interface1 , class Interface2 , class Interface3 , class Interface4 >
css::uno::Any | queryInterface (const css::uno::Type &rType, Interface1 *p1, Interface2 *p2, Interface3 *p3, Interface4 *p4)
| Compares demanded type to given template argument types. More...
template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 >
css::uno::Any | queryInterface (const css::uno::Type &rType, Interface1 *p1, Interface2 *p2, Interface3 *p3, Interface4 *p4, Interface5 *p5)
| Compares demanded type to given template argument types. More...
template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 >
css::uno::Any | queryInterface (const css::uno::Type &rType, Interface1 *p1, Interface2 *p2, Interface3 *p3, Interface4 *p4, Interface5 *p5, Interface6 *p6)
| Compares demanded type to given template argument types. More...
template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 , class Interface7 >
css::uno::Any | queryInterface (const css::uno::Type &rType, Interface1 *p1, Interface2 *p2, Interface3 *p3, Interface4 *p4, Interface5 *p5, Interface6 *p6, Interface7 *p7)
| Compares demanded type to given template argument types. More...
template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 , class Interface7 , class Interface8 >
css::uno::Any | queryInterface (const css::uno::Type &rType, Interface1 *p1, Interface2 *p2, Interface3 *p3, Interface4 *p4, Interface5 *p5, Interface6 *p6, Interface7 *p7, Interface8 *p8)
| Compares demanded type to given template argument types. More...
template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 , class Interface7 , class Interface8 , class Interface9 >
css::uno::Any | queryInterface (const css::uno::Type &rType, Interface1 *p1, Interface2 *p2, Interface3 *p3, Interface4 *p4, Interface5 *p5, Interface6 *p6, Interface7 *p7, Interface8 *p8, Interface9 *p9)
| Compares demanded type to given template argument types. More...
template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 , class Interface7 , class Interface8 , class Interface9 , class Interface10 >
css::uno::Any | queryInterface (const css::uno::Type &rType, Interface1 *p1, Interface2 *p2, Interface3 *p3, Interface4 *p4, Interface5 *p5, Interface6 *p6, Interface7 *p7, Interface8 *p8, Interface9 *p9, Interface10 *p10)
| Compares demanded type to given template argument types. More...
template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 , class Interface7 , class Interface8 , class Interface9 , class Interface10 , class Interface11 >
css::uno::Any | queryInterface (const css::uno::Type &rType, Interface1 *p1, Interface2 *p2, Interface3 *p3, Interface4 *p4, Interface5 *p5, Interface6 *p6, Interface7 *p7, Interface8 *p8, Interface9 *p9, Interface10 *p10, Interface11 *p11)
| Compares demanded type to given template argument types. More...
template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 , class Interface7 , class Interface8 , class Interface9 , class Interface10 , class Interface11 , class Interface12 >
css::uno::Any | queryInterface (const css::uno::Type &rType, Interface1 *p1, Interface2 *p2, Interface3 *p3, Interface4 *p4, Interface5 *p5, Interface6 *p6, Interface7 *p7, Interface8 *p8, Interface9 *p9, Interface10 *p10, Interface11 *p11, Interface12 *p12)
| Compares demanded type to given template argument types. More...
CPPUHELPER_DLLPUBLIC css::uno::Reference< css::uno::XInterface > | loadSharedLibComponentFactory (::rtl::OUString const &uri, ::rtl::OUString const &rPath, ::rtl::OUString const &rImplName, css::uno::Reference< css::lang::XMultiServiceFactory > const &xMgr, css::uno::Reference< css::registry::XRegistryKey > const &xKey)
| Loads a shared library component and gets the factory out of it. More...
CPPUHELPER_DLLPUBLIC void | writeSharedLibComponentInfo (::rtl::OUString const &uri, ::rtl::OUString const &rPath, css::uno::Reference< css::lang::XMultiServiceFactory > const &xMgr, css::uno::Reference< css::registry::XRegistryKey > const &xKey)
| Invokes component_writeInfo() function of specified component library. More...
bool CPPUHELPER_DLLPUBLIC | supportsService (css::lang::XServiceInfo *implementation, rtl::OUString const &name)
| A helper for implementations of com.sun.star.lang.XServiceInfo. More...
template<typename T >
::com::sun::star::uno::Type const & | getTypeFavourUnsigned (SAL_UNUSED_PARAMETER ::com::sun::star::uno::Sequence< T > const *)
template<typename T >
::com::sun::star::uno::Type const & | getTypeFavourChar (SAL_UNUSED_PARAMETER ::com::sun::star::uno::Sequence< T > const *)

## Typedef Documentation

## ◆ ComponentFactoryFunc

typedef css::uno::Reference< css::uno::XInterface >( * cppu::ComponentFactoryFunc) (css::uno::Reference< css::uno::XComponentContext > const &xContext)

Function pointer declaration.

Function creates component instance passing the component context to be used.

Parameters

  xContext | component context to be used

Returns
  component instance

## ◆ ComponentInstantiation

typedef css::uno::Reference< css::uno::XInterface >( * cppu::ComponentInstantiation) (const css::uno::Reference< css::lang::XMultiServiceFactory > &rServiceManager)

Deprecated.

The type of the instanciate function used as argument of the create*Factory functions.

See also
  createSingleFactory
  createOneInstanceFactory

Deprecated:

## ◆ OBroadcastHelper

typedef OBroadcastHelperVar< OMultiTypeInterfaceContainerHelper , OMultiTypeInterfaceContainerHelper::keyType > cppu::OBroadcastHelper

## Function Documentation

## ◆ bootstrap()

CPPUHELPER_DLLPUBLIC css::uno::Reference< css::uno::XComponentContext > cppu::bootstrap | ( |  | ) |

Bootstraps the component context from a UNO installation.

Returns
  a bootstrapped component context

Exceptions

  BootstrapException | Thrown in case bootstrap() signals an exception due to a bootstrap error.

Since
  UDK 3.2.0

## ◆ component_getFactoryHelper()

CPPUHELPER_DLLPUBLIC void* cppu::component_getFactoryHelper | ( | const sal_Char * | pImplName,
|  | void * | pServiceManager,
|  | void * | pRegistryKey,
|  | const struct ImplementationEntry | entries[]
| ) |  |

Helper function for implementation of the component_getFactory()-function, that must be implemented by every shared library component.

Parameters

  pImplName | The implementation-name to be instantiated ( This is the first parameter passed to the component_getFactory
  pServiceManager | The second parameter passed to component_getFactory()-function (This is a of the service manager, that creates the factory).
  pRegistryKey | The third parameter passed to the component_getFactory()-function. This is a reference to the registry key, where the implementation data has been written to.
  entries | Each element of the entries-array must contains a function pointer table for creating a factor of the implementation. The end of the array must be marked with a 0 entry in the create-function.

Returns
  0 if the helper failed to instantiate a factory, otherwise an acquired pointer to a factory.

## ◆ component_writeInfoHelper()

CPPUHELPER_DLLPUBLIC sal_Bool cppu::component_writeInfoHelper | ( | void * | pServiceManager,
|  | void * | pRegistryKey,
|  | const struct ImplementationEntry | entries[]
| ) |  |

Helper function for implementation of the component_writeInfo()-function.

Deprecated:
  component_writeInfo should no longer be used in new components

Parameters

  pServiceManager | The first parameter passed to component_writeInfo()-function (This is an instance of the service manager, that creates the factory).
  pRegistryKey | The second parameter passed to the component_writeInfo()-function. This is a reference to the registry key, into which the implementation data shall be written to.
  entries | Each element of the entries-array must contains a function pointer table for registering an implementation. The end of the array must be marked with a 0 entry in the create-function.

Returns
  sal_True, if all implementations could be registered, otherwise sal_False.

## ◆ convertPropertyValue() [1/12]

template<class target >

void cppu::convertPropertyValue | ( | target & | value,
|  | const css::uno::Any & | a
| ) |  |
| inline

Converts the value stored in an any to a concrete C++ type.

The function does the same as the operator >>= () at the Any class, except that it throws an IllegalArgumentException in case of failures (the value cannot be extracted without data loss )

Exceptions

  css::lang::IllegalArgumentException | when the type could not be converted.

## ◆ convertPropertyValue() [2/12]

void cppu::convertPropertyValue | ( | sal_Bool & | target,
|  | const css::uno::Any & | source
| ) |  |
| inline

conversion of basic types

## ◆ convertPropertyValue() [3/12]

void cppu::convertPropertyValue | ( | bool & | target,
|  | const css::uno::Any & | source
| ) |  |
| inline

## ◆ convertPropertyValue() [4/12]

void cppu::convertPropertyValue | ( | sal_Int64 & | target,
|  | const css::uno::Any & | source
| ) |  |
| inline

## ◆ convertPropertyValue() [5/12]

void cppu::convertPropertyValue | ( | sal_uInt64 & | target,
|  | const css::uno::Any & | source
| ) |  |
| inline

## ◆ convertPropertyValue() [6/12]

void cppu::convertPropertyValue | ( | sal_Int32 & | target,
|  | const css::uno::Any & | source
| ) |  |
| inline

## ◆ convertPropertyValue() [7/12]

void cppu::convertPropertyValue | ( | sal_uInt32 & | target,
|  | const css::uno::Any & | source
| ) |  |
| inline

## ◆ convertPropertyValue() [8/12]

void cppu::convertPropertyValue | ( | sal_Int16 & | target,
|  | const css::uno::Any & | source
| ) |  |
| inline

## ◆ convertPropertyValue() [9/12]

void cppu::convertPropertyValue | ( | sal_uInt16 & | target,
|  | const css::uno::Any & | source
| ) |  |
| inline

## ◆ convertPropertyValue() [10/12]

void cppu::convertPropertyValue | ( | sal_Int8 & | target,
|  | const css::uno::Any & | source
| ) |  |
| inline

## ◆ convertPropertyValue() [11/12]

void cppu::convertPropertyValue | ( | float & | target,
|  | const css::uno::Any & | source
| ) |  |
| inline

## ◆ convertPropertyValue() [12/12]

void cppu::convertPropertyValue | ( | double & | target,
|  | const css::uno::Any & | source
| ) |  |
| inline

## ◆ createComponentContext()

CPPUHELPER_DLLPUBLIC css::uno::Reference< css::uno::XComponentContext > cppu::createComponentContext | ( | ContextEntry_Init const * | pEntries,
|  | sal_Int32 | nEntries,
|  | css::uno::Reference< css::uno::XComponentContext > const & | xDelegate = `css::uno::Reference< css::uno::XComponentContext >()`
| ) |  |

Creates a component context with the given entries.

Parameters

  pEntries | array of entries
  nEntries | number of entries
  xDelegate | delegation to further context, if value was not found

Returns
  new context object

## ◆ createFactoryProxy()

CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleServiceFactory > cppu::createFactoryProxy | ( | const css::uno::Reference< css::lang::XMultiServiceFactory > & | rServiceManager,
|  | const css::uno::Reference< css::lang::XSingleServiceFactory > & | rFactory
| ) |  |

Deprecated.

Creates a factory wrapping another one. This means the methods of the interfaces XServiceProvider, XServiceInfo and XSingleServiceFactory are forwarded.

Attention
  The XComponent interface is not supported!

Parameters

  rServiceManager | the service manager used by the implementation.
  rFactory | the wrapped service factory.

Returns
  a factory that support the interfaces XServiceProvider, XServiceInfo XSingleServiceFactory.

See also
  createSingleFactory

Deprecated:

## ◆ createOneInstanceComponentFactory()

CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleComponentFactory > cppu::createOneInstanceComponentFactory | ( | ComponentFactoryFunc | fptr,
|  | ::rtl::OUString const & | rImplementationName,
|  | css::uno::Sequence< ::rtl::OUString > const & | rServiceNames,
|  | rtl_ModuleCount * | pModCount = `NULL`
| ) |  |

Creates a single service factory which holds the instance created only once.

Parameters

  fptr | function pointer for instanciating the object
  rImplementationName | implementation name of service
  rServiceNames | supported services
  pModCount | a backwards-compatibility remainder of a removed library unloading feature; always set to null

See also
  createSingleComponentFactory

## ◆ createOneInstanceFactory()

CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleServiceFactory > cppu::createOneInstanceFactory | ( | const css::uno::Reference< css::lang::XMultiServiceFactory > & | rServiceManager,
|  | const ::rtl::OUString & | rComponentName,
|  | ComponentInstantiation | pCreateFunction,
|  | const css::uno::Sequence< ::rtl::OUString > & | rServiceNames,
|  | rtl_ModuleCount * | pModCount = `NULL`
| ) |  |

Deprecated.

Creates a single service factory which holds the instance created only once.

Parameters

  rServiceManager | the service manager used by the implementation.
  rComponentName | the implementation name. An empty string is possible.
  pCreateFunction | the function pointer to create an object.
  rServiceNames | the service supported by the implementation.
  pModCount | a backwards-compatibility remainder of a removed library unloading feature; always set to null.

Returns
  a factory that support the interfaces XServiceProvider, XServiceInfo XSingleServiceFactory and XComponent.

See also
  createSingleFactory

Deprecated:

## ◆ createOneInstanceRegistryFactory()

CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleServiceFactory > cppu::createOneInstanceRegistryFactory | ( | const css::uno::Reference< css::lang::XMultiServiceFactory > & | rServiceManager,
|  | const ::rtl::OUString & | rComponentName,
|  | const css::uno::Reference< css::registry::XRegistryKey > & | rImplementationKey
| ) |  |

Deprecated.

Creates a single service factory which holds the instance created only once based on a registry.

Parameters

  rServiceManager | the service manager used by the implementation.
  rComponentName | the implementation name. An empty string is possible.
  rImplementationKey | the registry key of the implementation section.

Returns
  a factory that support the interfaces XServiceProvider, XServiceInfo XSingleServiceFactory and XComponent.

See also
  createSingleRegistryFactory

Deprecated:

## ◆ createSingleComponentFactory()

CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleComponentFactory > cppu::createSingleComponentFactory | ( | ComponentFactoryFunc | fptr,
|  | ::rtl::OUString const & | rImplementationName,
|  | css::uno::Sequence< ::rtl::OUString > const & | rServiceNames,
|  | rtl_ModuleCount * | pModCount = `NULL`
| ) |  |

Creates a single component factory supporting the XSingleComponentFactory interface.

Parameters

  fptr | function pointer for instanciating the object
  rImplementationName | implementation name of service
  rServiceNames | supported services
  pModCount | a backwards-compatibility remainder of a removed library unloading feature; always set to null

## ◆ createSingleFactory()

CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleServiceFactory > cppu::createSingleFactory | ( | const css::uno::Reference< css::lang::XMultiServiceFactory > & | rServiceManager,
|  | const ::rtl::OUString & | rImplementationName,
|  | ComponentInstantiation | pCreateFunction,
|  | const css::uno::Sequence< ::rtl::OUString > & | rServiceNames,
|  | rtl_ModuleCount * | pModCount = `NULL`
| ) |  |

Deprecated.

Creates a single service factory.

Parameters

  rServiceManager | the service manager used by the implementation.
  rImplementationName | the implementation name. An empty string is possible.
  pCreateFunction | the function pointer to create an object.
  rServiceNames | the service supported by the implementation.
  pModCount | a backwards-compatibility remainder of a removed library unloading feature; always set to null.

Returns
  a factory that support the interfaces XServiceProvider, XServiceInfo XSingleServiceFactory and XComponent.

See also
  createOneInstanceFactory

Deprecated:

## ◆ createSingleRegistryFactory()

CPPUHELPER_DLLPUBLIC css::uno::Reference< css::lang::XSingleServiceFactory > cppu::createSingleRegistryFactory | ( | const css::uno::Reference< css::lang::XMultiServiceFactory > & | rServiceManager,
|  | const ::rtl::OUString & | rImplementationName,
|  | const css::uno::Reference< css::registry::XRegistryKey > & | rImplementationKey
| ) |  |

Deprecated.

Creates a single service factory based on a registry.

Parameters

  rServiceManager | the service manager used by the implementation.
  rImplementationName | the implementation name. An empty string is possible.
  rImplementationKey | the registry key of the implementation section.

Returns
  a factory that support the interfaces XServiceProvider, XServiceInfo XSingleServiceFactory and XComponent.

Deprecated:

## ◆ defaultBootstrap_InitialComponentContext() [1/2]

CPPUHELPER_DLLPUBLIC css::uno::Reference< css::uno::XComponentContext > cppu::defaultBootstrap_InitialComponentContext | ( |  | ) |

Bootstraps an initial component context with service manager upon information from bootstrap variables.

This function tries to find its parameters via these bootstrap variables:

- UNO_TYPES – a space separated list of file urls of type rdbs
- UNO_SERVICES – a space separated list of file urls of service rdbs

Please look at http://udk.openoffice.org/common/man/concept/uno_default_bootstrapping.html for further info.

Returns
  component context

## ◆ defaultBootstrap_InitialComponentContext() [2/2]

CPPUHELPER_DLLPUBLIC css::uno::Reference< css::uno::XComponentContext > cppu::defaultBootstrap_InitialComponentContext | ( | const ::rtl::OUString & | iniFile | ) |

Bootstraps an initial component context with service manager upon information from an ini file.

This function tries to find its parameters via these bootstrap variables:

- UNO_TYPES – a space separated list of file urls of type rdbs
- UNO_SERVICES – a space separated list of file urls of service rdbs

Please look at http://udk.openoffice.org/common/man/concept/uno_default_bootstrapping.html for further info.

Parameters

  iniFile | ini filename to get bootstrap variables

Returns
  component context

## ◆ Enterable_call_callInto_v()

void cppu::Enterable_call_callInto_v | ( | void * | context,
|  | uno_EnvCallee * | pCallee,
|  | va_list * | pParam
| ) |  |
| inline

## ◆ Enterable_call_callOut_v()

void cppu::Enterable_call_callOut_v | ( | void * | context,
|  | uno_EnvCallee * | pCallee,
|  | va_list * | pParam
| ) |  |
| inline

## ◆ Enterable_call_enter()

void cppu::Enterable_call_enter | ( | void * | context | ) |
| inline

## ◆ Enterable_call_isValid()

int cppu::Enterable_call_isValid | ( | void * | context,
|  | rtl_uString ** | pReason
| ) |  |
| inline

## ◆ Enterable_call_leave()

void cppu::Enterable_call_leave | ( | void * | context | ) |
| inline

## ◆ getCaughtException()

CPPUHELPER_DLLPUBLIC css::uno::Any cppu::getCaughtException | ( |  | ) |

Use this function to get the dynamic type of a caught C++-UNO exception; completes the above function throwing exceptions generically.

try
{
...
}
catch (css::uno::RuntimeException &)
{
// you ought not handle RuntimeExceptions:
throw;
}
catch (css::uno::Exception &)
{
css::uno::Any caught( ::cppu::getCaughtException() );
...
}

Restrictions:

- use only for caught C++-UNO exceptions (UNOIDL defined)
- only as first statement in a catch block!
- don't do a C++ rethrow (throw;) after you have called this function
- call getCaughtException() just once in your catch block! (function internally uses a C++ rethrow)

Returns
  caught UNO exception

Attention
  Caution! This function is limited to the same C++ compiler runtime library. E.g. for MSVC, this means that the catch handler code (the one that calls getCaughtException()) needs to use the very same C++ runtime library, e.g. msvcrt.dll as cppuhelper, e.g. cppuhelper3MSC.dll and the bridge library, e.g. msci_uno.dll. This is the case if all of them are compiled with the same compiler version. Background: The msci_uno.dll gets a rethrown exception out of the internal msvcrt.dll thread local storage (tls). Thus you must not use this function if your code needs to run in newer UDK versions without being recompiled, because those newer UDK (-> OOo versions) potentially use newer C++ runtime libraries which most often become incompatible!

But this function ought to be usable for most OOo internal C++-UNO development, because the whole OOo code base is compiled using the same C++ compiler (and linking against one runtime library).

## ◆ getTypeFavourChar()

template<typename T >

::com::sun::star::uno::Type const& cppu::getTypeFavourChar | ( | SAL_UNUSED_PARAMETER ::com::sun::star::uno::Sequence< T > const * |  | ) |
| inline

## ◆ getTypeFavourUnsigned() [1/4]

template<typename T >

::com::sun::star::uno::Type const& cppu::getTypeFavourUnsigned | ( | SAL_UNUSED_PARAMETER ::com::sun::star::uno::Sequence< T > const * |  | ) |
| inline

## ◆ getTypeFavourUnsigned() [2/4]

template<typename T >

css::uno::Type const& cppu::getTypeFavourUnsigned | ( | SAL_UNUSED_PARAMETER T const * |  | ) |
| inline

A working replacement for getCppuType (see there).

There are three overloads of this function that together form the replacement of getCppuType. The replacement has exactly the same semantics as getCppuType, in that it returns correct results for the UNO type UNSIGNED SHORT but not for the UNO type CHAR.

Since
  UDK 3.2.2

## ◆ getTypeFavourUnsigned() [3/4]

css::uno::Type const& cppu::getTypeFavourUnsigned | ( | SAL_UNUSED_PARAMETER ::sal_uInt16 const * |  | ) |
| inline

A working replacement for getCppuType (see there).

There are three overloads of this function that together form the replacement of getCppuType. The replacement has exactly the same semantics as getCppuType, in that it returns correct results for the UNO type UNSIGNED SHORT but not for the UNO type CHAR.

Since
  UDK 3.2.2

## ◆ getTypeFavourUnsigned() [4/4]

template<typename T >

css::uno::Type const& cppu::getTypeFavourUnsigned | ( | css::uno::Sequence< T > const * |  | ) |
| inline

A working replacement for getCppuType (see there).

There are three overloads of this function that together form the replacement of getCppuType. The replacement has exactly the same semantics as getCppuType, in that it returns correct results for the UNO type UNSIGNED SHORT but not for the UNO type CHAR.

Since
  UDK 3.2.2

## ◆ installTypeDescriptionManager()

CPPUHELPER_DLLPUBLIC sal_Bool cppu::installTypeDescriptionManager | ( | css::uno::Reference< css::container::XHierarchicalNameAccess > const & | xTDMgr | ) |

Installs type description manager instance, i.e.

registers a callback at cppu core.

Parameters

  xTDMgr | manager instance

Returns
  true, if successfully registered

## ◆ loadSharedLibComponentFactory()

CPPUHELPER_DLLPUBLIC css::uno::Reference< css::uno::XInterface > cppu::loadSharedLibComponentFactory | ( | ::rtl::OUString const & | uri,
|  | ::rtl::OUString const & | rPath,
|  | ::rtl::OUString const & | rImplName,
|  | css::uno::Reference< css::lang::XMultiServiceFactory > const & | xMgr,
|  | css::uno::Reference< css::registry::XRegistryKey > const & | xKey
| ) |  |

Loads a shared library component and gets the factory out of it.

You can give either a fully qualified libname or single lib name. The libname need not be pre/postfixed (e.g. xxx.dll).

Deprecated:
  This should never have been put into the URE interface. Do not call it from client code.

Parameters

  uri | URI of the library
  rPath | deprecated, must be empty
  rImplName | implementation to be retrieved from the library
  xMgr | service manager to be provided to the component
  xKey | deprecated, must be null

Returns
  factory instance (css::lang::XSingleComponentFactory or legacy css::lang::XSingleServiceFactory)

## ◆ mapIn()

template<class T >

T* cppu::mapIn | ( | T * | pT,
|  | css::uno::Environment const & | outerEnv
| ) |  |
| inline

Maps an object from an outer Environment to the current, returns mapped object.

Parameters

  pT | the object to be mapped
  outerEnv | the source environment

Returns
  the mapped object

Since
  UDK 3.2.7

## ◆ mapInAny()

void cppu::mapInAny | ( | css::uno::Any const & | any,
|  | css::uno::Any * | res,
|  | css::uno::Environment const & | outerEnv
| ) |  |
| inline

Maps an any from an outer Environment to the current, fills passed any.

Parameters

  any | the any to be mapped
  res | the target any
  outerEnv | the source environment

Since
  UDK 3.2.7

## ◆ mapOut()

template<class T >

T* cppu::mapOut | ( | T * | pT,
|  | css::uno::Environment const & | outerEnv
| ) |  |
| inline

Helpers for mapping objects relative to the current environment.

(http://wiki.openoffice.org/wiki/Uno/Cpp/Spec/Map_Helpers)Maps an object from the current to an outer Environment, returns mapped object.

Parameters

  pT | the object to be mapped
  outerEnv | the target environment

Returns
  the mapped object

Since
  UDK 3.2.7

## ◆ mapOutAny()

void cppu::mapOutAny | ( | css::uno::Any const & | any,
|  | css::uno::Any * | res,
|  | css::uno::Environment const & | outerEnv
| ) |  |
| inline

Maps an any from the current to an outer Environment, fills passed any.

Parameters

  any | the any to be mapped
  res | the target any
  outerEnv | the target environment

Since
  UDK 3.2.7

## ◆ queryInterface() [1/12]

template<class Interface1 >

css::uno::Any cppu::queryInterface | ( | const css::uno::Type & | rType,
|  | Interface1 * | p1
| ) |  |
| inline

Compares demanded type to given template argument types.

Template Parameters

  Interface1 | interface type

Parameters

  rType | demanded type
  p1 | interface pointer

Returns
  acquired interface of demanded type or empty Any

## ◆ queryInterface() [2/12]

template<class Interface1 , class Interface2 >

css::uno::Any cppu::queryInterface | ( | const css::uno::Type & | rType,
|  | Interface1 * | p1,
|  | Interface2 * | p2
| ) |  |
| inline

Compares demanded type to given template argument types.

Template Parameters

  Interface1 | interface type
  Interface2 | interface type

Parameters

  rType | demanded type
  p1 | interface pointer
  p2 | interface pointer

Returns
  acquired interface of demanded type or empty Any

## ◆ queryInterface() [3/12]

template<class Interface1 , class Interface2 , class Interface3 >

css::uno::Any cppu::queryInterface | ( | const css::uno::Type & | rType,
|  | Interface1 * | p1,
|  | Interface2 * | p2,
|  | Interface3 * | p3
| ) |  |
| inline

Compares demanded type to given template argument types.

Template Parameters

  Interface1 | interface type
  Interface2 | interface type
  Interface3 | interface type

Parameters

  rType | demanded type
  p1 | interface pointer
  p2 | interface pointer
  p3 | interface pointer

Returns
  acquired interface of demanded type or empty Any

## ◆ queryInterface() [4/12]

template<class Interface1 , class Interface2 , class Interface3 , class Interface4 >

css::uno::Any cppu::queryInterface | ( | const css::uno::Type & | rType,
|  | Interface1 * | p1,
|  | Interface2 * | p2,
|  | Interface3 * | p3,
|  | Interface4 * | p4
| ) |  |
| inline

Compares demanded type to given template argument types.

Template Parameters

  Interface1 | interface type
  Interface2 | interface type
  Interface3 | interface type
  Interface4 | interface type

Parameters

  rType | demanded type
  p1 | interface pointer
  p2 | interface pointer
  p3 | interface pointer
  p4 | interface pointer

Returns
  acquired interface of demanded type or empty Any

## ◆ queryInterface() [5/12]

template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 >

css::uno::Any cppu::queryInterface | ( | const css::uno::Type & | rType,
|  | Interface1 * | p1,
|  | Interface2 * | p2,
|  | Interface3 * | p3,
|  | Interface4 * | p4,
|  | Interface5 * | p5
| ) |  |
| inline

Compares demanded type to given template argument types.

Template Parameters

  Interface1 | interface type
  Interface2 | interface type
  Interface3 | interface type
  Interface4 | interface type
  Interface5 | interface type

Parameters

  rType | demanded type
  p1 | interface pointer
  p2 | interface pointer
  p3 | interface pointer
  p4 | interface pointer
  p5 | interface pointer

Returns
  acquired interface of demanded type or empty Any

## ◆ queryInterface() [6/12]

template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 >

css::uno::Any cppu::queryInterface | ( | const css::uno::Type & | rType,
|  | Interface1 * | p1,
|  | Interface2 * | p2,
|  | Interface3 * | p3,
|  | Interface4 * | p4,
|  | Interface5 * | p5,
|  | Interface6 * | p6
| ) |  |
| inline

Compares demanded type to given template argument types.

Template Parameters

  Interface1 | interface type
  Interface2 | interface type
  Interface3 | interface type
  Interface4 | interface type
  Interface5 | interface type
  Interface6 | interface type

Parameters

  rType | demanded type
  p1 | interface pointer
  p2 | interface pointer
  p3 | interface pointer
  p4 | interface pointer
  p5 | interface pointer
  p6 | interface pointer

Returns
  acquired interface of demanded type or empty Any

## ◆ queryInterface() [7/12]

template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 , class Interface7 >

css::uno::Any cppu::queryInterface | ( | const css::uno::Type & | rType,
|  | Interface1 * | p1,
|  | Interface2 * | p2,
|  | Interface3 * | p3,
|  | Interface4 * | p4,
|  | Interface5 * | p5,
|  | Interface6 * | p6,
|  | Interface7 * | p7
| ) |  |
| inline

Compares demanded type to given template argument types.

Template Parameters

  Interface1 | interface type
  Interface2 | interface type
  Interface3 | interface type
  Interface4 | interface type
  Interface5 | interface type
  Interface6 | interface type
  Interface7 | interface type

Parameters

  rType | demanded type
  p1 | interface pointer
  p2 | interface pointer
  p3 | interface pointer
  p4 | interface pointer
  p5 | interface pointer
  p6 | interface pointer
  p7 | interface pointer

Returns
  acquired interface of demanded type or empty Any

## ◆ queryInterface() [8/12]

template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 , class Interface7 , class Interface8 >

css::uno::Any cppu::queryInterface | ( | const css::uno::Type & | rType,
|  | Interface1 * | p1,
|  | Interface2 * | p2,
|  | Interface3 * | p3,
|  | Interface4 * | p4,
|  | Interface5 * | p5,
|  | Interface6 * | p6,
|  | Interface7 * | p7,
|  | Interface8 * | p8
| ) |  |
| inline

Compares demanded type to given template argument types.

Template Parameters

  Interface1 | interface type
  Interface2 | interface type
  Interface3 | interface type
  Interface4 | interface type
  Interface5 | interface type
  Interface6 | interface type
  Interface7 | interface type
  Interface8 | interface type

Parameters

  rType | demanded type
  p1 | interface pointer
  p2 | interface pointer
  p3 | interface pointer
  p4 | interface pointer
  p5 | interface pointer
  p6 | interface pointer
  p7 | interface pointer
  p8 | interface pointer

Returns
  acquired interface of demanded type or empty Any

## ◆ queryInterface() [9/12]

template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 , class Interface7 , class Interface8 , class Interface9 >

css::uno::Any cppu::queryInterface | ( | const css::uno::Type & | rType,
|  | Interface1 * | p1,
|  | Interface2 * | p2,
|  | Interface3 * | p3,
|  | Interface4 * | p4,
|  | Interface5 * | p5,
|  | Interface6 * | p6,
|  | Interface7 * | p7,
|  | Interface8 * | p8,
|  | Interface9 * | p9
| ) |  |
| inline

Compares demanded type to given template argument types.

Template Parameters

  Interface1 | interface type
  Interface2 | interface type
  Interface3 | interface type
  Interface4 | interface type
  Interface5 | interface type
  Interface6 | interface type
  Interface7 | interface type
  Interface8 | interface type
  Interface9 | interface type

Parameters

  rType | demanded type
  p1 | interface pointer
  p2 | interface pointer
  p3 | interface pointer
  p4 | interface pointer
  p5 | interface pointer
  p6 | interface pointer
  p7 | interface pointer
  p8 | interface pointer
  p9 | interface pointer

Returns
  acquired interface of demanded type or empty Any

## ◆ queryInterface() [10/12]

template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 , class Interface7 , class Interface8 , class Interface9 , class Interface10 >

css::uno::Any cppu::queryInterface | ( | const css::uno::Type & | rType,
|  | Interface1 * | p1,
|  | Interface2 * | p2,
|  | Interface3 * | p3,
|  | Interface4 * | p4,
|  | Interface5 * | p5,
|  | Interface6 * | p6,
|  | Interface7 * | p7,
|  | Interface8 * | p8,
|  | Interface9 * | p9,
|  | Interface10 * | p10
| ) |  |
| inline

Compares demanded type to given template argument types.

Template Parameters

  Interface1 | interface type
  Interface2 | interface type
  Interface3 | interface type
  Interface4 | interface type
  Interface5 | interface type
  Interface6 | interface type
  Interface7 | interface type
  Interface8 | interface type
  Interface9 | interface type
  Interface10 | interface type

Parameters

  rType | demanded type
  p1 | interface pointer
  p2 | interface pointer
  p3 | interface pointer
  p4 | interface pointer
  p5 | interface pointer
  p6 | interface pointer
  p7 | interface pointer
  p8 | interface pointer
  p9 | interface pointer
  p10 | interface pointer

Returns
  acquired interface of demanded type or empty Any

## ◆ queryInterface() [11/12]

template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 , class Interface7 , class Interface8 , class Interface9 , class Interface10 , class Interface11 >

css::uno::Any cppu::queryInterface | ( | const css::uno::Type & | rType,
|  | Interface1 * | p1,
|  | Interface2 * | p2,
|  | Interface3 * | p3,
|  | Interface4 * | p4,
|  | Interface5 * | p5,
|  | Interface6 * | p6,
|  | Interface7 * | p7,
|  | Interface8 * | p8,
|  | Interface9 * | p9,
|  | Interface10 * | p10,
|  | Interface11 * | p11
| ) |  |
| inline

Compares demanded type to given template argument types.

Template Parameters

  Interface1 | interface type
  Interface2 | interface type
  Interface3 | interface type
  Interface4 | interface type
  Interface5 | interface type
  Interface6 | interface type
  Interface7 | interface type
  Interface8 | interface type
  Interface9 | interface type
  Interface10 | interface type
  Interface11 | interface type

Parameters

  rType | demanded type
  p1 | interface pointer
  p2 | interface pointer
  p3 | interface pointer
  p4 | interface pointer
  p5 | interface pointer
  p6 | interface pointer
  p7 | interface pointer
  p8 | interface pointer
  p9 | interface pointer
  p10 | interface pointer
  p11 | interface pointer

Returns
  acquired interface of demanded type or empty Any

## ◆ queryInterface() [12/12]

template<class Interface1 , class Interface2 , class Interface3 , class Interface4 , class Interface5 , class Interface6 , class Interface7 , class Interface8 , class Interface9 , class Interface10 , class Interface11 , class Interface12 >

css::uno::Any cppu::queryInterface | ( | const css::uno::Type & | rType,
|  | Interface1 * | p1,
|  | Interface2 * | p2,
|  | Interface3 * | p3,
|  | Interface4 * | p4,
|  | Interface5 * | p5,
|  | Interface6 * | p6,
|  | Interface7 * | p7,
|  | Interface8 * | p8,
|  | Interface9 * | p9,
|  | Interface10 * | p10,
|  | Interface11 * | p11,
|  | Interface12 * | p12
| ) |  |
| inline

Compares demanded type to given template argument types.

Template Parameters

  Interface1 | interface type
  Interface2 | interface type
  Interface3 | interface type
  Interface4 | interface type
  Interface5 | interface type
  Interface6 | interface type
  Interface7 | interface type
  Interface8 | interface type
  Interface9 | interface type
  Interface10 | interface type
  Interface11 | interface type
  Interface12 | interface type

Parameters

  rType | demanded type
  p1 | interface pointer
  p2 | interface pointer
  p3 | interface pointer
  p4 | interface pointer
  p5 | interface pointer
  p6 | interface pointer
  p7 | interface pointer
  p8 | interface pointer
  p9 | interface pointer
  p10 | interface pointer
  p11 | interface pointer
  p12 | interface pointer

Returns
  acquired interface of demanded type or empty Any

## ◆ supportsService()

bool CPPUHELPER_DLLPUBLIC cppu::supportsService | ( | css::lang::XServiceInfo * | implementation,
|  | rtl::OUString const & | name
| ) |  |

A helper for implementations of com.sun.star.lang.XServiceInfo.

This function is supposed to be called from implementations of css::lang::XServiceInfo::supportsService (and therefore, for easier coding takes the caller's this pointer by pointer rather than by css::uno::Reference).

Parameters

  implementation | points to the service implementation whose getSupportedServices method is consulted; must be non-null
  name | the service name to test

Returns
  true iff the sequence returned by the given implementation's getSupportedServices method contains the given name

Since
  LibreOffice 4.0

## ◆ throwException()

CPPUHELPER_DLLPUBLIC void cppu::throwException | ( | const css::uno::Any & | rExc | ) |

This function throws the exception given by rExc.

The given value has to be of typeclass EXCEPTION and must be derived from or of type com.sun.star.uno.Exception.

Parameters

  rExc | exception to be thrown.

## ◆ writeSharedLibComponentInfo()

CPPUHELPER_DLLPUBLIC void cppu::writeSharedLibComponentInfo | ( | ::rtl::OUString const & | uri,
|  | ::rtl::OUString const & | rPath,
|  | css::uno::Reference< css::lang::XMultiServiceFactory > const & | xMgr,
|  | css::uno::Reference< css::registry::XRegistryKey > const & | xKey
| ) |  |

Invokes component_writeInfo() function of specified component library.

You can give either a fully qualified libname or single lib name. The libname need not be pre/postfixed (e.g. xxx.dll).

Deprecated:
  This should never have been put into the URE interface. Do not call it from client code. Also, this functionality is not needed for passively registered components, only for actively registered legacy ones.

Parameters

  uri | URI of the library
  rPath | deprecated, must be empty
  xMgr | service manager to be provided to the component
  xKey | registry key to be provided to the component